## crafty 23.1

=== Makefile ===
--- 
+++ 
@@ -38,10 +38,7 @@
 #                     to use in a SMP system.  Note that this is the max you
 #                     will be able to use.  You need to use the smpmt=n command
 #                     to make crafty use more than the default 1 process.
-#   -DDGT          N  This is a unix-only option to support the DGT board.
 #   -DEPD          Y  if you want full EPD support built in.
-#   -DHASHSTATS    N  This option compiles in some of the statistics 
-#                     gathering to provide hashing statistics.
 #   -DINLINE32     N  Compiles with the Intel assembly code for FirstOne(),
 #                     LastOne() and PopCnt().  This is for gcc-style inlining
 #                     and now works with the Intel C/C++ compiler as well.
@@ -61,16 +58,13 @@
 #   -DPOWERPC      N  enables PPC spinlock inline function for SMP boxes only
 #   -DRCDIR        N  path to the directory where we look for the .craftyrc or
 #                     crafty.rc (windows) file.
-#   -DSMP          N  enables SMP support (not clustering).  If you choose
-#                     this option, you need to look closely at the following
-#                     two options as well.
 #   -DTBDIR        N  path to the directory where the endgame tablebase files
 #                     are found.  default = "./TB"
 #   -DTRACE        N  This enables the "trace" command so that the search tree
 #                     can be dumped while running.
 
 default:
-	$(MAKE) -j linux-icc
+	$(MAKE) linux
 help:
 	@echo "You must specify the system which you want to compile for:"
 	@echo ""
@@ -103,44 +97,24 @@
 		opt='$(opt)' \
 		crafty-make
 
-alpha:
-	$(MAKE) target=ALPHA \
-		CC=cc CXX=cxx \
-		CFLAGS='$(CFLAGS) -std -fast -O4 -newc' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
-		LIBS='-lexc' \
-		opt='$(opt)' \
-		crafty-make
-
-alpha-host:
-	$(MAKE) target=ALPHA \
-		CC=cc CXX=cxx \
-		CFLAGS='$(CFLAGS) -std -fast -O4 -newc -arch host' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
-		LIBS='-lexc' \
-		opt='$(opt)' \
-		crafty-make
-
 darwin:
 	$(MAKE) target=FreeBSD \
 		CC=gcc CXX=g++ \
 		CFLAGS='$(CFLAGS) -Wall -pipe -O3' \
 		CXFLAGS=$(CFLAGS) \
 		LDFLAGS=$(LDFLAGS) \
-		LIBS='-lstdc++' \
+		LIBS='-lpthread -lstdc++' \
 		opt='$(opt)' \
 		crafty-make
 
 darwinG5:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O3 -mcpu=G5 \
+		CFLAGS='$(CFLAGS) -Wall -pipe -O3 -mcpu=G5 \
 			-mtune=G5 -fomit-frame-pointer -fast' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
-		opt='$(opt) -DSMP -DCPUS=4 -DPOWERPC' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
+		opt='$(opt) -DCPUS=4 -DPOWERPC' \
 		crafty-make
 	
 freebsd:
@@ -148,16 +122,16 @@
 		CC=gcc CXX='$(CC)' \
 		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
 freebsd-pgcc:
 	$(MAKE) target=FreeBSD \
 		CC=gcc CXX='$(CC)' \
-		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O -Wall' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		CFLAGS='$(CFLAGS) -pipe -mpentium -O -Wall' \
+		CXFLAGS=$(CFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
@@ -172,109 +146,98 @@
 linux-amd64-profile:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-                CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
+                CFLAGS='$(CFLAGS) -Wall -pipe \
                         -fprofile-arcs -fomit-frame-pointer -O3 -march=k8' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lnuma -fprofile-arcs -lstdc++' \
-		opt='$(opt) -DINLINE64 -DSMP -DCPUS=8 -DNUMA -DLIBNUMA' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lnuma -fprofile-arcs -lstdc++' \
+		opt='$(opt) -DINLINE64 -DCPUS=8 -DNUMA -DLIBNUMA' \
 		crafty-make
 
 linux-amd64:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-                CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
+                CFLAGS='$(CFLAGS) -Wall -pipe \
                 -fbranch-probabilities -fomit-frame-pointer -O3 -march=k8' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lnuma -lstdc++' \
-		opt='$(opt) -DINLINE64 -DSMP -DCPUS=8 -DNUMA -DLIBNUMA' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lnuma -lstdc++' \
+		opt='$(opt) -DINLINE64 -DCPUS=8 -DNUMA -DLIBNUMA' \
 		crafty-make
 
 linux:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
-			-fbranch-probabilities -fforce-mem -fomit-frame-pointer\
+		CFLAGS='$(CFLAGS) -Wall -pipe -march=i686 -O3 \
 			-fno-gcse -mpreferred-stack-boundary=2' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
+		opt='$(opt) -DTRACE -DINLINE32 -DCPUS=2' \
 		crafty-make
 
 linux-profile:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
+		CFLAGS='$(CFLAGS) -Wall -pipe -march=i686 -O3 \
 			-fprofile-arcs -fforce-mem -fomit-frame-pointer \
 			-fno-gcse -mpreferred-stack-boundary=2' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -fprofile-arcs -lstdc++ ' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++ ' \
+		opt='$(opt) -DINLINE32 -DCPUS=2' \
 		crafty-make
 
 linux-icc:
 	$(MAKE) target=LINUX \
 		CC=icc CXX=icc \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CFLAGS='$(CFLAGS) -O2 \
 			-xN -prof_use -prof_dir ./profdir \
 			-Ob2 -fno-alias' \
-		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CXFLAGS='$(CFLAGS) -O2 \
 			-w -xN -prof_use -prof_dir ./profdir' \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
+		opt='$(opt) -DTEST -DINLINE32 -DCPUS=4' \
 		crafty-make
 
 linux-icc-profile:
 	$(MAKE) target=LINUX \
 		CC=icc CXX=icc \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CFLAGS='$(CFLAGS) -O2 \
 			-xN -prof_genx -prof_dir ./profdir \
 			-Ob2 -fno-alias' \
-		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CXFLAGS='$(CFLAGS) -O2 \
 			-w -xN -prof_genx -prof_dir ./profdir' \
-		LDFLAGS='$(LDFLAGS) -lstdc++ ' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
-		crafty-make
-
-linux-alpha:
-	$(MAKE) target=ALPHA \
-		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -O4 -ffast-math -funroll-loops' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
-		LIBS='' \
-		opt='$(opt) -DNOBUILTINS' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++ ' \
+		opt='$(opt) -DTEST -DINLINE32 -DCPUS=2' \
 		crafty-make
 
 netbsd:
 	$(MAKE) target=NetBSD \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
+		CFLAGS='$(CFLAGS) -O3 -Wall \
 			-fomit-frame-pointer -funroll-all-loops \
 			-finline-functions -ffast-math' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
 netbsd-i386:
 	$(MAKE) target=NetBSD \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
+		CFLAGS='$(CFLAGS) -O3 -Wall -m486 \
 			-fomit-frame-pointer -funroll-all-loops \
 			-finline-functions -ffast-math' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
 netbsd-sparc:
 	$(MAKE) target=NetBSD \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
+		CFLAGS='$(CFLAGS) -O3 -Wall \
 			-fomit-frame-pointer -funroll-all-loops \
 			-finline-functions -ffast-math' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt)' \
 		crafty-make
 
@@ -283,7 +246,7 @@
 		CC=/bin/cc CXX='$(CC)' \
 		CFLAGS='$(CFLAGS) -O2' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)'
+		LDFLAGS='$(LDFLAGS) $(CFLAGS) -lpthread'
 		opt='$(opt)' \
 		crafty-make
 
@@ -293,7 +256,7 @@
 		AFLAGS='-P' \
 		CFLAGS='$(CFLAGS) -32 -mips2 -cckr' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt)' \
 		crafty-make
 
@@ -302,17 +265,17 @@
 		CC=cc CXX='$(CC)' \
 		CFLAGS='$(CFLAGS) -fast -xO5 -xunroll=20' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS)' \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt)' \
 		crafty-make
 
 solaris-gcc:
 	$(MAKE) target=SUN \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O2 \
+		CFLAGS='$(CFLAGS) -Wall -pipe -O2 \
 			-fforce-mem -fomit-frame-pointer' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
 		opt='$(opt)' \
 		crafty-make
 
@@ -321,7 +284,7 @@
 	@rm -rf position.bin
 	@mkdir profdir
 	@touch *.c *.cpp *.h
-	$(MAKE) linux-icc-profile
+	$(MAKE) linux-profile
 	@echo "#!/bin/csh" > runprof
 	@echo "./crafty <<EOF" >>runprof
 	@echo "st=10" >>runprof
@@ -344,3 +307,25 @@
 	@echo "move" >>runprof
 	@echo "setboard 2r3k1/pppR1pp1/4p3/4P1P1/5P2/1P4K1/P1P5/8 w" >>runprof
 	@echo "move" >>runprof
+	@echo "setboard 1nk1r1r1/pp2n1pp/4p3/q2pPp1N/b1pP1P2/B1P2R2/2P1B1PP/R2Q2K1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 4b3/p3kp2/6p1/3pP2p/2pP1P2/4K1P1/P3N2P/8 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 2kr1bnr/pbpq4/2n1pp2/3p3p/3P1P1B/2N2N1Q/PPP3PP/2KR1B1R w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 3rr1k1/pp3pp1/1qn2np1/8/3p4/PP1R1P2/2P1NQPP/R1B3K1 b" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 2r1nrk1/p2q1ppp/bp1p4/n1pPp3/P1P1P3/2PBB1N1/4QPPP/R4RK1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r3r1k1/ppqb1ppp/8/4p1NQ/8/2P5/PP3PPP/R3R1K1 b" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r2q1rk1/4bppp/p2p4/2pP4/3pP3/3Q4/PP1B1PPP/R3R1K1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard rnb2r1k/pp2p2p/2pp2p1/q2P1p2/8/1Pb2NP1/PB2PPBP/R2Q1RK1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 2r3k1/1p2q1pp/2b1pr2/p1pp4/6Q1/1P1PP1R1/P1PN2PP/5RK1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r1bqkb1r/4npp1/p1p4p/1p1pP1B1/8/1B6/PPPN1PPP/R2Q1RK1 w kq" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r2q1rk1/1ppnbppp/p2p1nb1/3Pp3/2P1P1P1/2N2N1P/PPB1QP2/R1B2RK1 b" >>runprof
+	@echo "move" >>runprof
