=== debian/changelog ===
crafty (23.4-9) unstable; urgency=medium

  * Adopt package inside Games Team (Closes: #835321)
  * Remove kfreebsd-amd64 support

 -- Alexandre Detiste <tchet@debian.org>  Wed, 02 Apr 2025 11:23:43 +0200

crafty (23.4-8) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.9.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files
  * Moved to debhelper compat level 13.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 28 Apr 2024 00:53:58 +0200

crafty (23.4-7) unstable; urgency=medium

  * QA upload.
  * Raise debhelper compat level to 9.
  * Drop README.source. Package is in "3.0 (quilt)" format.
  * Package is orphaned (Bug #835321), set Maintainer to "Debian QA Group".
  * Do not generate CPU specific code. Should fix "Illegal instruction" on
    some Pentium 4 CPUs. Closes: #850979.
  * Drop emacs local variables from the changelog.
  * Drop spurious spaces in several files.

 -- Santiago Vila <sanvila@debian.org>  Wed, 11 Jan 2017 20:02:00 +0100

crafty (23.4-6) unstable; urgency=low

  * Ubuntus oneiric build faild, because with linking the order of
    options matters. Oneiric uses ld-as-needed. Applied patch from
    Daniel T Chen <seven.steps@gmail.com>, thanks. (Closes: #641383)

 -- Oliver Korff <ok@xynyx.de>  Thu, 13 Oct 2011 22:22:40 +0200

crafty (23.4-5) unstable; urgency=low

  * Added a build dependency on kfreebsd-amd64 on libnuma-dev. Now FTBFS
    should be solved there.
  * Update to Standards-Version: 3.9.2 No changes.

 -- Oliver Korff <ok@xynyx.de>  Mon, 23 May 2011 15:58:07 +0200

crafty (23.4-4) unstable; urgency=low

  * The changes for 23.4-3 were highly supported by Mike Rohleder
    <mike@rohleder.de> this had to be clarified. Thanks!
  * Stripped README.Debian a bit and deleted deprecated entries
    of the previous maintainer, Eric Van Buggenhaut
    <ericvb@debian.org> (Closes: #621051)
  * The setgid r/w files in /var/lib/crafty have not been tolerable
    and are not necessary, if crafty is used in a $HOME/.crafty
    setup. This is ATM supported by executing the setup-crafty.sh
    from /usr/share/doc/crafty. Removed documetation of the old
    setup README.Debian. (Closes: #621052)

 -- Oliver Korff <ok@xynyx.de>  Wed, 06 Apr 2011 17:15:49 +0200

crafty (23.4-3) unstable; urgency=low

  * Small changes to annotata.c make the annotation with .png graphics
    possible. This will be useful with the crafty-bitmaps package. And
    later close the related bug, if the crafty-bitmaps package hit the
    contrib repository.
  * Displaying crafty.hlp by crafty could not bedone, dh_compress
    compresses it. So crafty.hlp is now excluded.

 -- Oliver Korff <ok@xynyx.de>  Mon, 04 Apr 2011 21:10:27 +0200

crafty (23.4-2) unstable; urgency=low

  * Update to the version from experimental. Upload to experimental was only done,
    not to mix up anything with the release and to test the build on architectures.

 -- Oliver Korff <ok@xynyx.de>  Mon, 28 Feb 2011 12:06:49 +0100

crafty (23.4-1) experimental; urgency=low

  * New Upstream Version
  * Repack of the source, to remove binary content.
  * Upload to experimental, to test the build of the different architectures.
  * Switch to Quilt and Source format 3.0. Moved all build intelligence to
    the new debian rules.
  * Because of architecture dependent building issues this upload is done to
    experimental. The correct built on amd64 was tested on pergolesi, the other
    systems have to be reconsidered, if the buildds show problems.

 -- Oliver Korff <ok@xynyx.de>  Wed, 12 Jan 2011 08:55:22 +0100

crafty (23.3-1) unstable; urgency=low

  * New Upstream Version
  * Because crafty as non-free software is now built by the buildds
    architecture dependent building issues were encountered. They result
    from the optimizing code inside of crafty. The solution is to include
    the optimizing only there, where it is working. So there are now more
    architecture dependent targets in the debian rules file.
    (Closes: #593111)
  * Update to Standards Version: 3.9.1

 -- Oliver Korff <ok@xynyx.de>  Thu, 19 Aug 2010 11:02:47 +0200

crafty (23.2-1) unstable; urgency=low

  * New Upstream Version
  * The 01-Makefile patch had to be recreated, because of too many
    changes by upstream. The linux-generic target has been added for
    building on other architectures. It has been tested in general
    at i386.
  * There was a -pg profiling switch in the linux target in
    the Makefile, this was corrected.
  * Corrected a small spelling error in the binary.

 -- Oliver Korff <ok@xynyx.de>  Sat, 06 Mar 2010 12:17:41 +0100

crafty (23.1-1) unstable; urgency=low

  * Started over with repackaging from fresh debhelper templates
  * Used a copy of: control, changelog, copyright, crafty.6, craftyrc.5,
    README.Debian and crafty.rc.
  * Removed menu. I don't want to depend on xboard, but this would be
    necessary, if I use a menu entry with xboard.
  * The 01_Makefile patch had to be adjusted.
  * New Upstream Release

 -- Oliver Korff <ok@xynyx.de>  Thu, 07 Jan 2010 00:18:16 +0100

crafty (22.10-4) unstable; urgency=low

  * To make autobuild possible on different architectures
    the Makefile was extended by a linux-generic target.
    (Closes: #549587) This was done by generating the 01-Makefile
    patch. The former 01-build patch is included now and removed.
  * The linux generic target was stripped of any optimizations
  * Set a build depends for libnuma-dev only where it is
    used by the makefile: libnuma-dev [amd64]

 -- Oliver Korff <ok@xynyx.de>  Mon, 05 Oct 2009 20:44:56 +0200

crafty (22.10-3) unstable; urgency=low

  * To repair amd64 build issues a patch of Christoph Berg
    <myon@debian.org> was added to the patchset
  * The 01-build.dpatch had to be corrected
  * Included the newest copyright notice of the upstream author

