=== debian/control ===
Source: crafty
Section: non-free/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libnuma-dev [amd64],
Standards-Version: 4.7.2
XS-Autobuild: yes
Homepage: https://craftychess.com/
Vcs-Browser: https://salsa.debian.org/games-team/crafty
Vcs-Git: https://salsa.debian.org/games-team/crafty.git
Rules-Requires-Root: no
X-Style: black

Package: crafty
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 crafty-books-medtosmall | crafty-books-small,
 xboard,
Description: state-of-the-art chess engine, compatible with xboard
 Crafty is the strong chess program played on ICC. It uses all of the
 search algorithms you have probably read about and performs better
 than gnu-chess in most positions. It has a reasonable set of features to use,
 and offers a great starting point to try your own new search extensions.
