=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

TARGET := darwin

ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
TARGET := linux-amd64
endif

%:
	dh $@

override_dh_auto_build:
	$(MAKE) $(TARGET)

override_dh_auto_clean:
	$(MAKE) clean
	rm -f *.o crafty game* log* position* books.bin book.bin book.lrn *.gcno lala
	rm -rf debian/tmp

override_dh_auto_test:
	@echo "Little Test"
	@echo "sd 15" > lala
	@echo "e4" >> lala
	@echo "end" >> lala
	@echo "input lala" | ./crafty

override_dh_installchangelogs:
	mkdir -p debian/x
	grep '^ \*' main.c > debian/x/changelog
	dh_installchangelogs debian/x/changelog
	rm debian/x/changelog

override_dh_compress:
	dh_compress -Xcrafty.hlp
