=== debian/watch ===
version=4

ftp://ftp.cis.uab.edu/pub/hyatt/source/crafty-([\d.]+)\.zip
